/*
 * str2wcscpy.c
 * Copyright (C) 2015-2016 Peter Belkner <pbelkner@snafu.de>
 *
 * This file is part of libya.
 *
 * libya is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libya is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with libya.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <ya.h>

wchar_t *str2wcscpy(wchar_t *wcs, const char *str, int codepage, size_t size)
{
  MultiByteToWideChar(
    codepage,     // _In_      UINT   CodePage,
    0,            // _In_      DWORD  dwFlags,
    str,          // _In_      LPCSTR lpMultiByteStr,
    -1,           // _In_      int    cbMultiByte,
    wcs,          // _Out_opt_ LPWSTR lpWideCharStr,
    size          // _In_      int    cchWideChar
  );

  return wcs;
}
