/*
 * wchar2char.h
 * Copyright (C) 2015-2016 Peter Belkner <pbelkner@snafu.de>
 *
 * This file is part of libya.
 *
 * libya is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libya is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with libya.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <ya.h>

char *wc2cscpy(char *str, const wchar_t *wcs, int codepage, size_t size)
{
  WideCharToMultiByte(
    codepage,     // _In_      UINT    CodePage,
    0,            // _In_      DWORD   dwFlags,
    wcs,          // _In_      LPCWSTR lpWideCharStr,
    -1,           // _In_      int     cchWideChar,
    str,          // _Out_opt_ LPSTR   lpMultiByteStr,
    size,         // _In_      int     cbMultiByte,
    NULL,         // _In_opt_  LPCSTR  lpDefaultChar,
    NULL          // _Out_opt_ LPBOOL  lpUsedDefaultChar
  );

  return str;
}
